<?php 
// File: $Id: tools.php,v 1.17 2004/04/27 21:34:19 markwest Exp $ $Name: HEAD $
// ----------------------------------------------------------------------
// PostNuke Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file:
// Purpose of file:
// ----------------------------------------------------------------------
// include 'modules/NS-User/user/database.php';

if (eregi('tools.php', $_SERVER['PHP_SELF'])) {
	die ("You can't access this file directly...");
}

include 'modules/NS-User/user/menu.php';
include 'modules/NS-User/user/access.php';
// include 'modules/NS-User/user/language.php';
function redirect_index($message, $url = "index.php")
{
    //$ThemeSel = pnConfigGetVar('Default_Theme');
	$ThemeSel = pnUserGetTheme();
    echo "<html><head><META HTTP-EQUIV=Refresh CONTENT=\"2; URL=$url\">\n";
    if (defined("_CHARSET") && _CHARSET != "") {
        echo "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=" . _CHARSET . "\">\n";
    } 
    echo "<LINK REL=\"StyleSheet\" href=\"".WHERE_IS_PERSO."themes/$ThemeSel/style/styleNN.css\" type=\"text/css\">\n";
    echo "<style type=\"text/css\">";
    echo "@import url(\"".WHERE_IS_PERSO."themes/$ThemeSel/style/style.css\"); ";
    echo "</style>\n";
    echo "</head><body bgcolor=\"$GLOBALS[bgcolor1]\" text=\"$GLOBALS[textcolor1]\">\n";
    echo "<div style=\"text-align:center\" class=\"pn-title\">$message</div></body></html>";

} 

function redirect_user()
{
    //$ThemeSel = pnConfigGetVar('Default_Theme');
	$ThemeSel = pnUserGetTheme();
    echo "<html><head><META HTTP-EQUIV=Refresh CONTENT=\"2; URL=user.php\">\n";
    if (defined("_CHARSET") && _CHARSET != "") {
        echo "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=" . _CHARSET . "\">\n";
    } 
    echo " <LINK REL=\"StyleSheet\" href=\"".WHERE_IS_PERSO."themes/$ThemeSel/style/style.css\" type=\"text/css\">\n";
    echo "<style type=\"text/css\">";
    echo "@import url(\"".WHERE_IS_PERSO."themes/$ThemeSel/style/style.css\"); ";
    echo "</style>\n";
    echo "</head><body bgcolor=\"$GLOBALS[bgcolor1]\" text=\"$GLOBALS[textcolor1]\">\n";
    echo "<div style=\"text-align:center\" class=\"pn-title\">" . _INFOCHANGED . "</div></body></html>";
} 

function docookie($setuid, $setuname, $setpass, $setstorynum, $setumode, $setuorder, $setthold, $setnoscore, $setublockon, $settheme, $setcommentmax)
{
    $info = base64_encode("$setuid:$setuname:$setpass:$setstorynum:$setumode:$setuorder:$setthold:$setnoscore:$setublockon:$settheme:$setcommentmax");
    setcookie("user", "$info", time() + 15552000);
} 
// for compatibility : use user_menu_add_option($url,$title,$image)
function usermenu($url, $title, $image)
{
    if (!ereg('/', $image)) $image = pnConfigGetVar('userimg') . "/" . $image;
    user_menu_add_option($url, $title, $image);
} 

function GraphicUser($help = '')
{ 
    // modified by Chris van de Steeg.. I guess this should display the menu
    // it didn't do that.
    // if ($help!='') user_menu_help($help,_ONLINEMANUAL);
    user_menu($help); 
    // user_menu_detail(false);
    user_menu_draw();
} 

function user_menu($help_file = '')
{
    $pntable =& pnDBGetTables();

    user_menu_title('user.php', _THISISYOURPAGE);
    user_menu_graphic(pnConfigGetVar('usergraphic'));
    if ($help_file != '') user_menu_help($help_file, _ONLINEMANUAL); 
    // include 'modules/NS-Modules/data.php';
    // foreach ($module_item as $k=>$item)
    // user_menu_add_option('user.php?module='.$item['module'].'&op=main',$item['text'],$item['image']);
    // modules, old way
	$usermods = pnModGetAllMods();
	foreach ($usermods as $usermod) {
		$modinfo = pnModGetInfo(pnModGetIDFromName($usermod['name']));
        if (@is_dir($dir = 'modules/' . pnVarPrepForOS($modinfo['directory']) . '/user/links/')) {
            $linksdir = opendir("modules/" . pnVarPrepForOS($modinfo['directory']) . "/user/links/");
            while ($func = readdir($linksdir)) {
                if (eregi('^links.', $func)) {
                    // modified by Chris van de Steeg to have $ModName available in the links file
                    // $menulist[$func] = "modules/$modulename/user/links";
                    $menulist[$func]["dir"] = 'modules/' . pnVarPrepForOS($modinfo['directory']) . '/user/links';
					// this should really be $usermod['name'] but this leaves of the ns-prefix - markwest
                    $menulist[$func]["modname"] = $usermod['directory']; 
                    // end mofication by Chris van de Steeg
                } 
            } 
            closedir($linksdir);
        } 
    }

    // display
    ksort($menulist);
    foreach ($menulist as $k => $v) {
        // modified by Chris van de Steeg to have $ModName available in the links file
        // $currMod = $GLOBALS["ModName"]; //moved a bit down by Andy Varganov
        $GLOBALS["ModName"] = $v["modname"];
        $currMod = $GLOBALS["ModName"];
        include $v['dir'] . '/' . pnVarPrepForOS($k);
        $GLOBALS["ModName"] = $currMod; 
        // end mofication by Chris van de Steeg
    } 
    user_menu_add_option('user.php?module=NS-User&amp;op=logout', _LOGOUTEXIT, 'modules/NS-Your_Account/images/exit.gif');
} 

function user_title($title)
{
    OpenTable();
    echo "<div style=\"text-align:center\"><span class=\"pn-title\"><strong>" . pnVarPrepForDisplay($title) . "</strong></span></div>";
    CloseTable();
} 

function user_submit($module, $op, $text)
{
    echo '<input type="hidden" name="module" value="' . $module . '" />' . "\n" 
		. '<input type="hidden" name="op" value="' . $op . '" />' . "\n" 
		. '<input type="submit" value="' . $text . '" />' . "\n";
} 

?>